# coding: utf-8

"""
    Ambient API

     This API provides access to Ambient services. It is designed to be used by Ambient applications and services. 

    The version of the OpenAPI document: 0.8.2
    Contact: jose@ambientlabscomputing.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from ambient_backend_api_client.models.token_type import TokenType
from typing import Optional, Set
from typing_extensions import Self

class Token(BaseModel):
    """
    Token
    """ # noqa: E501
    token_type: TokenType
    duration: Optional[StrictInt] = 3600
    user_id: Optional[StrictInt] = None
    org_id: Optional[StrictInt] = None
    node_id: Optional[StrictInt] = None
    id: StrictInt
    value: StrictStr
    value_hash: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["token_type", "duration", "user_id", "org_id", "node_id", "id", "value", "value_hash"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Token from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if user_id (nullable) is None
        # and model_fields_set contains the field
        if self.user_id is None and "user_id" in self.model_fields_set:
            _dict['user_id'] = None

        # set to None if org_id (nullable) is None
        # and model_fields_set contains the field
        if self.org_id is None and "org_id" in self.model_fields_set:
            _dict['org_id'] = None

        # set to None if node_id (nullable) is None
        # and model_fields_set contains the field
        if self.node_id is None and "node_id" in self.model_fields_set:
            _dict['node_id'] = None

        # set to None if value_hash (nullable) is None
        # and model_fields_set contains the field
        if self.value_hash is None and "value_hash" in self.model_fields_set:
            _dict['value_hash'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Token from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "token_type": obj.get("token_type"),
            "duration": obj.get("duration") if obj.get("duration") is not None else 3600,
            "user_id": obj.get("user_id"),
            "org_id": obj.get("org_id"),
            "node_id": obj.get("node_id"),
            "id": obj.get("id"),
            "value": obj.get("value"),
            "value_hash": obj.get("value_hash")
        })
        return _obj


